using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Xml;
using System.IO;

namespace FeedHandlerLib
{
    public class ATOMFeedGenerator
    {
        public static string GetATOM()
        {
            MemoryStream ms = new MemoryStream();
            XmlTextWriter writer = new XmlTextWriter(ms, null);
            SqlConnection cnn = new SqlConnection(ConfigurationManager.ConnectionStrings["connstr"].ConnectionString);
            SqlCommand cmd = new SqlCommand("select * from articles order by pubdate desc", cnn);
            cnn.Open();
            SqlDataReader reader = cmd.ExecuteReader();
            writer.WriteStartElement("feed");
            writer.WriteAttributeString("xmlns", "http://www.w3.org/2005/Atom");
            writer.WriteElementString("id", "www.somedomain.com");
            writer.WriteElementString("title", "MyWebSite.com");
            writer.WriteElementString("link", "http://mywebsite.com");
            writer.WriteElementString("updated", DateTime.Now.ToString("yyyy-MM-ddThh:mm:ssZ"));
            
            writer.WriteStartElement("author");
            writer.WriteElementString("name", "Mr.Abcd");
            writer.WriteElementString("email", "someemail@somedomain.com");
            writer.WriteEndElement();

            while (reader.Read())
            {
                writer.WriteStartElement("entry");
                writer.WriteElementString("title", reader.GetString(reader.GetOrdinal("title")));
                writer.WriteElementString("id", "www.somedomain.com");
                writer.WriteElementString("updated", reader.GetDateTime(reader.GetOrdinal("pubdate")).ToString("yyyy-MM-ddThh:mm:ssZ"));
                writer.WriteElementString("link", reader.GetString(reader.GetOrdinal("url")));
                writer.WriteElementString("summary", reader.GetString(reader.GetOrdinal("description")));
                writer.WriteEndElement();
            }
            writer.WriteEndElement();
            reader.Close();
            cnn.Close();
            writer.BaseStream.Flush();
            writer.Flush();
            ms.Flush();
            byte[] data = new byte[ms.Length];
            ms.Seek(0, SeekOrigin.Begin);
            ms.Read(data, 0, data.Length);
            ms.Close();
            return ASCIIEncoding.ASCII.GetString(data);
        }

    }
}
